/* -*-C-*- strtok.c */
/*-->strtok*/
/**********************************************************************/
/****************************** strtok ********************************/
/**********************************************************************/

#include "headers.h"

#if defined(HAVE_STRTOK)
static int have_strtok = 0;		/* ensure non-empty object file */
					/* because some linkers reject them */
#else
RCSID("$Id: strtok.c,v 1.1 1997/09/01 22:26:35 beebe Exp beebe $")


/* This is a simple implementation of strtok().	 A library version
should use hardware support, or unrolled loops, to improve
performance. */

char*
#if STDC
strtok(
char  *s,		/* non-NULL on first call, NULL on subsequent ones */
const char  *sepchars	/* separator characters */
)
#else /* NOT STDC */
strtok(s,sepchars)
char  *s;		/* non-NULL on first call, NULL on subsequent ones */
const char  *sepchars;	/* separator characters */
#endif /* STDC */
{
	static char  *s_init = (char*)NULL;
	char  *start;
	char  *end;

	if (s != (char*)NULL)		/* initial call for this s[] */
		s_init = s;
	else if ((s_init == (char*)NULL) || (*s_init == '\0'))
		return ((char*)NULL);

	/* resume scan from saved token start */

	for (start = s_init; *start && strchr(sepchars,*start) != (char*)NULL;
		start++)
		/* skip over leading separators */;
	if (*start == '\0')
		return ((char*)NULL);
	for (end = start; *end && strchr(sepchars,*end) == (char*)NULL; end++)
		/* skip over token */;
	s_init = *end ? end+1 : end;	/* next token starts past this */
					/* but not beyond end of string */
	*end = '\0';			/* terminate current token */
	return (start);			/* and return pointer to it */
}
#endif /* defined(HAVE_STRTOK) */
